#include <stdio.h>
#include <errno.h>

size_t fread(void *ptr,size_t size,size_t nmemb,FILE *f)
{
  size_t cnt,total=size*nmemb;
  char *p=ptr;
  long result;

  if (!f) {
    errno = EBADF;
    return (0);
  }
  if ((f->flags&(_READABLE|_WRITE|_ERR|_EOF))!=_READABLE) {
    errno = EBADF;
    return (0);
  }
  f->flags |= _READ;
  if (cnt=f->count) {
    /* read buffer */
    if (total<=cnt) {
      memcpy(p,f->pointer,total);
      f->pointer += total;
      f->count -= total;
      return (nmemb);
    }
    else {
      memcpy(p,f->pointer,cnt);
      total -= cnt;
      p += cnt;
      f->count = 0;
    }
  }
  if ((result = _read(f->filehandle,p,total)) == EOF) {
    f->flags |= _ERR;
    return (0);
  }
  else if (result<total) {
    f->flags |= _EOF;
    return ((cnt+result)/size);
  }
  return (nmemb);
}
